bump = require 'bump'
Timer = require 'timer'
state = require "stateswitcher"
game = require ('game')



player = {}
enemies = {}
move_rad= 100
anstable = {0,0}
clouds = {}
bullets = {}
bulletSpeed = 250
player.x=0
player.y=0
player.width=32
player.height=64
player.name= "player"
final_score = 0
tele_okay = true
 
world = bump.newWorld()

function love.load()
  --comment out the below line to improve performance a bit. it allows for console comments via "print()".
  --io.stdout:setvbuf('no')
  fontFancy = love.graphics.setNewFont("Saiyan-Sans.ttf",40)
  fontDef = love.graphics.newFont(40)
  love.window.setMode( 1100,600 )
  love.graphics.setBackgroundColor( 66, 66, 200 )
  
  instructions = love.graphics.newImage('instructions.png')
  gameoversign = love.graphics.newImage('gameoversign.png')
  startButton = love.graphics.newImage('start.png')
  restartButton = love.graphics.newImage('restart.png')
  playerpic = love.graphics.newImage('player.png')
  enemyApic = love.graphics.newImage('enemyA.png')
  enemyBpic = love.graphics.newImage('enemyB.png')
  enemyCpic = love.graphics.newImage('enemyC.png')
  telepic = love.graphics.newImage('teleport.png')
  shotpic = love.graphics.newImage('shot.png')
  teleEffect = love.graphics.newParticleSystem(telepic, 32)
  teleEffect:setParticleLifetime(0.75)
  teleEffect:setColors(255,255,255,255,255,255,255,0,255,255,255,255,255,255,255,0,255,255,255,255,255,255,255,0)
  
  img = love.graphics.newImage("bs1.png")
  splat1 = love.graphics.newParticleSystem(img, 40)
  splat1:setParticleLifetime(0.5)
  splat1:setSizes(1,2,3)
  splat1:setRotation(10,20)
  splat1:setColors(255, 255, 255, 200, 255, 255, 255, 100, 255, 255, 255, 50,255, 255, 255, 0)
  splat1:setSizes(2,4,6)
  
  start = {scale = 1,x=(love.graphics.getWidth()/2 -startButton:getWidth()/2),y=450}
  
  tweentimer = Timer.new()
  
end

function love.mousepressed(x,y,key)
  if (key == 1 and 
    x > start.x and x < start.x+ startButton:getWidth() and
    y > start.y and y< start.y+ startButton:getHeight() ) then
    
  purge_all()
  Timer.clear()
  tele_okay = true
  
  
  player.x=0
  player.y=0
  player.width=32
  player.height=64
  player.name= "player"
  world:add(player, player.x,player.y,player.width,player.height)
  score=0 
  Timer.every(1,function() score=score+1 end)-- raise it by 1 every second.
  
  enemy_counter= 0
  Timer.every(3,newEnemy) -- Spawn a new enemy every 3 seconds!
  
  Timer.every(1.5,enemyAI)
  --]]
    state.switch "game"
    
  end
  
end


function love.update(dt)
  Timer.update(dt)
  --[[ IF MOUSE IS INSIDE START BUTTON
   if (
    love.mouse.getX() > start.x and love.mouse.getX() < start.x+ startButton:getWidth() and
    love.mouse.getX() > start.y and love.mouse.getX()< start.y+ startButton:getHeight() ) then
    start.color
    
  end
  --]]
  
end

function love.draw()
  
  love.graphics.print("Quick Transmission",love.graphics.getWidth()/4+80 , 40,0,1.5,1.5)
  love.graphics.draw(instructions,(love.graphics.getWidth()/2 -instructions:getWidth()/2),175)
  love.graphics.draw(startButton,start.x,start.y,0,start.scale,start.scale)
  
end

function love.keypressed(key)
  if key=='q' then
    state.switch "main"
  elseif key=='w' then
    
  ---[[These should be activated once every time you re-enter the "game" state.
  purge_all()
  Timer.clear()
  
  
  player.x=0
  player.y=0
  player.width=32
  player.height=64
  player.name= "player"
  world:add(player, player.x,player.y,player.width,player.height)
  score=0 
  Timer.every(1,function() score=score+1 end)-- raise it by 1 every second.
  
  enemy_counter= 0
  Timer.every(3,newEnemy) -- Spawn a new enemy every 3 seconds!
  
  Timer.every(1.5,enemyAI)
  --]]
    state.switch "game"
  elseif key=='e' then
    state.switch "gameover"
  end
end

function purge_all()
  tablePurge(enemies)
  tablePurge(bullets)
  tablePurge(player)
end

-- Delete all elements from a table.
-- Removes the appropriate stuff from the "bump" world, as well!
-- Specify if you need removal from the bump world.
function tablePurge(table) 
  if table.name == 'player' and world:hasItem(table) then
    world:remove(table)
  end
  
  for i,v in pairs(table) do
    if (world:hasItem(v)) then
      world:remove(v)
    end
    table[i] = nil
  end
  
end

